/*SpUpd!_2018.02.19_0000641*/
/*needVer=2018.02.19_0000640*/

CREATE OR ALTER procedure PROV_PLAN (
    LPU integer,
    PROF smallint,
    OPLAT smallint,
    TS smallint,
    DEND date,
    KOD_MES varchar(16))
returns (
    ERR char(1),
    ERR2 char(1))
as
declare variable GR integer;
declare variable GS integer;
declare variable GG integer;
declare variable GK integer;
declare variable UROV smallint;
declare variable M smallint;
declare variable PR_NAME varchar(80);
declare variable VID_MP varchar(30);
begin
  gr=0; gs=0; gg=0; gk=0;
  m=extract(month from dend);
  select sum(coalesce(p2.ry_m,0)) gr, sum(coalesce(p2.sy_m,0)) gs, sum(coalesce(p2.gy_m,0)) gg, sum(coalesce(p2.ky_m,0)) gk from planindex p,plan2month p2
  where p.lpu=:lpu and p.oplat=:oplat and p.ts=:ts and p.profile=:prof and
        p2.plan_idx=p.id and p2.n_month=:M
  into :gr, :gs, :gg, :gk;

  if ((gr>0) or (gs>0) or (gk>0) or (gg>0)) then err='0';
  else
      begin
            select trim(pr.name) from profil pr
            where pr.tip_prof=:prof
            into :PR_NAME;
            
            select substring(v.naim from 1 for 4) naim from vidoplat v
            where v.oplat=:OPLAT
            into :VID_MP;
            
            err = (PR_NAME||' ('||prof||') / '||VID_MP);
      end

  urov=0;

  if (ts=1) then
  begin
    if (char_length(kod_mes)<=7) then urov=cast(substring(kod_mes from 1 for 1) as smallint);
    if (char_length(kod_mes)>=12) then urov=cast(substring(kod_mes from 12 for 1) as smallint)+2;
  end

  if ((urov=0) or    -- urov=0,  TS<>1
    ((urov=3) and ((gr>0) or (gs>0))) or
    ((urov<=4) and (gg>0)) or
    ((urov<=5) and (gk>0))) then err2='0';      --    
    else err2='1';

  if (err<>'0') then err2='0';   --     
  suspend;
end;
@
commit work;
@